try:
    import uke_08_oppg_4 as D
except ModuleNotFoundError:
    import oppgaver.uke_08_oppg_4 as D

N_seats = 15
parties = ["H", "Ap", "FrP", "SP", "SV", "KrF", "R", "V", "MdG"]
votes = [
    74282,
    68945,
    38352,
    29981,
    26901,
    14724,
    14150,
    13163,
    11940,
]

hordaland_res = D.valgresultat(parties, votes, N_seats)
mandater = D.parti_mandater(parties, votes, N_seats)


def test_hordaland_top_15():
    assert D.valgresultat(parties, votes, N_seats) == [
        (53058.571428571435, "H"),
        (49246.42857142857, "Ap"),
        (27394.285714285717, "FrP"),
        (24760.666666666668, "H"),
        (22981.666666666668, "Ap"),
        (21415.0, "SP"),
        (19215.0, "SV"),
        (14856.4, "H"),
        (13789.0, "Ap"),
        (12784.0, "FrP"),
        (10611.714285714286, "H"),
        (10517.142857142859, "KrF"),
        (10107.142857142857, "R"),
        (9993.666666666666, "SP"),
        (9849.285714285714, "Ap"),
    ]


def test_hordaland_tuple():
    assert D.parti_mandater(parties, votes, N_seats) == [
        ("H", 74282, 4),
        ("Ap", 68945, 4),
        ("FrP", 38352, 2),
        ("SP", 29981, 2),
        ("SV", 26901, 1),
        ("KrF", 14724, 1),
        ("R", 14150, 1),
    ]


N_seats_2 = 11
parties_2 = ["H", "Ap", "FrP", "SP", "SV", "KrF", "R", "V", "MdG"]
votes_2 = [
    81140,
    80862,
    39851,
    12187,
    26295,
    11229,
    14150,
    13163,
    11940,
]

top_11 = D.valgresultat(parties_2, votes_2, N_seats_2)
mandater_2 = D.parti_mandater(parties_2, votes_2, N_seats_2)


def test_top_11():
    assert top_11 == [
        (57957.14285714286, "H"),
        (57758.571428571435, "Ap"),
        (28465.0, "FrP"),
        (27046.666666666668, "H"),
        (26954.0, "Ap"),
        (18782.14285714286, "SV"),
        (16228.0, "H"),
        (16172.4, "Ap"),
        (13283.666666666666, "FrP"),
        (11591.42857142857, "H"),
        (11551.714285714286, "Ap"),
    ]


def test_tuple():
    assert mandater_2 == [
        ("H", 81140, 4),
        ("Ap", 80862, 4),
        ("FrP", 39851, 2),
        ("SV", 26295, 1),
    ]
